<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 06/19/2004 *
 * ===================                          Last change: 12/26/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-rallye.php                                   *
 * -------------------------------------------------------------------- *
 * Short description : Referral rallye                                  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Referral Rallyes starten                         *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2012 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Version number
setThisExtensionVersion('0.3.7');

// Version history array (add more with , '0.0.1' and so on)
setExtensionVersionHistory(array('0.0.0', '0.0.1', '0.0.2', '0.0.3', '0.0.4', '0.0.5', '0.0.6', '0.0.7', '0.0.8', '0.0.9', '0.1.0', '0.1.1', '0.1.2', '0.1.3', '0.1.4', '0.1.5', '0.1.6', '0.1.7', '0.1.8', '0.1.9', '0.2.0', '0.2.1', '0.2.2', '0.2.3', '0.2.4', '0.2.5', '0.2.6', '0.2.7', '0.2.8', '0.2.9', '0.3.0', '0.3.1', '0.3.2', '0.3.3', '0.3.4', '0.3.5', '0.3.6', '0.3.7'));

switch (getExtensionMode()) {
	case 'register': // Do stuff when installation is running
		// SQL commands to run
		addDropTableSql('rallye_data');
		addCreateTableSql('rallye_data', "
`id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`admin_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`title` VARCHAR(255) NOT NULL DEFAULT '',
`descr` LONGTEXT NOT NULL,
`template` VARCHAR(255) NOT NULL DEFAULT '',
`start_time` VARCHAR(10) NOT NULL DEFAULT 0,
`end_time` VARCHAR(10) NOT NULL DEFAULT 0,
`auto_add_new_user` ENUM('Y','N') NOT NULL DEFAULT 'Y',
`is_active` ENUM('Y','N') NOT NULL DEFAULT 'N',
`send_notify` ENUM('Y','N') NOT NULL DEFAULT 'Y',
`notified` ENUM('Y','N') NOT NULL DEFAULT 'N',
PRIMARY KEY (`id`),
INDEX (`admin_id`)",
			'Main rallye data');

		addDropTableSql('rallye_prices');
		addCreateTableSql('rallye_prices', "
`id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`rallye_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`price_level` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`points` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`info` LONGTEXT NOT NULL,
PRIMARY KEY (`id`),
INDEX (`rallye_id`)",
			'Prices data for a rallye');

		addDropTableSql('rallye_users');
		addCreateTableSql('rallye_users', "
`id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`rallye_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`userid` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`refs` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
PRIMARY KEY (`id`),
INDEX (`rallye_id`),
INDEX (`userid`)",
			'Rallye->user connection table');

		// Admin menu
		addAdminMenuSql('rallye', NULL, 'Rallye-Management','Richten Sie neue Ref-Rallyes ein, die zeitgesteuert anfangen und aufh&ouml;hren. Dabei wird alles weitere automatisch geregelt.',9);
		addAdminMenuSql('rallye','add_rallye','Neue Rallye hinzuf&uuml;gen','Neue Ref-Rallye hinzuf&uuml;gen.',1);
		// @TODO Fix config_rallye_prices to list_rallye_prices
		addAdminMenuSql('rallye','config_rallye_prices','Preise einrichten','Richten Sie Preise zu den Rallyes ein.',2);
		addAdminMenuSql('rallye','list_rallyes','Rallyes verwalten','Alle bestehenden Ref-Rallyes auflisten, bearbeiten, stoppen, l&ouml;schen usw.',3);

		// Guest menu
		addGuestMenuSql('main', 'rallyes', 'Ref-Rallyes', 9);

		// Member menu
		addMemberMenuSql('main', 'rallyes', 'Ref-Rallyes', 9);
		break;

	case 'remove': // Do stuff when removing extension
		// Drop tables
		addDropTableSql('rallye_data');
		addDropTableSql('rallye_prices');
		addDropTableSql('rallye_users');

		// Remove menus
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_admin_menu` WHERE `action`='rallye'");
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_guest_menu` WHERE `what`='rallyes' LIMIT 1");
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE `what`='rallyes' LIMIT 1");

		// Remove points_data entry
		unregisterExtensionPointsData('rallye_winner');

		// Unregister filter
		unregisterFilter(__FILE__, __LINE__, 'extra_autopurge', 'RALLYE_EXTRA_AUTOPURGE', true, isExtensionDryRun());
		unregisterFilter(__FILE__, __LINE__, 'init', 'RALLYE_NOTIFY_USERS', true, isExtensionDryRun());
		unregisterFilter(__FILE__, __LINE__, 'add_rallye_notify_sqls', 'ADD_RALLYE_SQL_COLUMNS', true, isExtensionDryRun());
		break;

	case 'activate': // Do stuff when admin activates this extension
		// SQL commands to run
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_guest_menu` SET `visible`='Y',`locked`='N' WHERE `what`='rallyes' LIMIT 1");
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `visible`='Y',`locked`='N' WHERE `what`='rallyes' LIMIT 1");
		break;

	case 'deactivate': // Do stuff when admin deactivates this extension
		// SQL commands to run
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_guest_menu` SET `visible`='N',`locked`='Y' WHERE `what`='rallyes' LIMIT 1");
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `visible`='N',`locked`='Y' WHERE `what`='rallyes' LIMIT 1");
		break;

	case 'update': // Update an extension
		switch (getCurrentExtensionVersion()) {
			case '0.0.1': // SQL queries for v0.0.1
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_rallye_data` ADD `expired` ENUM('Y','N') NOT NULL DEFAULT 'N'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Ablaufen der Rallyes intergriert.");
				break;

			case '0.0.2': // SQL queries for v0.0.2
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_rallye_users` ADD `curr_points` FLOAT(20,5) UNSIGNED NOT NULL DEFAULT 0.00000");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Aktueller {?POINTS?}-Stand wird beachtet.");
				break;

			case '0.0.6': // SQL queries for v0.0.6
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehler <span class=\"notice\">Unknown column 'd.useid' in 'on clause'</span> behoben.");
				break;

			case '0.0.7': // SQL queries for v0.0.7
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehlende Abfrage im Mitlieder-Modul, on Erweiterung auch aktiviert ist.");
				break;

			case '0.0.8': // SQL queries for v0.0.8
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehler <u>Template nicht gefunden</u> behoben und Admin-Formulare ausgelagert");
				break;

			case '0.0.9': // SQL queries for v0.0.9
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist. Und der vorherige Fehler <u>Template nicht gefunden</u> ist endlich beseitigt.");
				break;

			case '0.1.0': // SQL queries for v0.2.1
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_rallye_users` CHANGE `curr_points` `curr_points` FLOAT(23,5) UNSIGNED NOT NULL DEFAULT 0.00000");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("5 Nachkommastellen implementiert.");
				break;

			case '0.1.1': // SQL queries for v0.1.1
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.");
				break;

			case '0.1.2': // SQL queries for v0.1.2
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Problem mit Speicherung der Einstellungen beseitigt.");
				break;

			case '0.1.3': // SQL queries for v0.1.3
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Anzeigefehler im Gast-/Mitgliedsbereich behoben.");
				break;

			case '0.1.4': // SQL queries for v0.1.4
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Admin-Mails korregiert.");
				break;

			case '0.1.5': // SQL queries for v0.1.5
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Men&uuml;punkte im Gast-/Mitgliedsbereich k&ouml;nnen nicht mehr aufgerufen werden, wenn die Erweiterung deaktiviert ist.");
				break;

			case '0.1.6': // SQL queries for v0.1.6
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Seit <strong>Patch 340</strong> &uuml;berfl&uuml;ssige HTML-Tags entfernt.");
				break;

			case '0.1.7': // SQL queries for v0.1.7
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Aktivierte bzw. abgelaufene Rallyes werden nur ausserhalb des CSS-Modus geladen (wenn also nicht css.php aufgerufen wurde)");
				break;

			case '0.1.8': // SQL queries for v0.1.8
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Weitere Templates vom Admin-Bereich ausgelagert und Referral-Anazahl in der Mail zur Rallye-Ank&uuml;ndigung repariert.");
				break;

			case '0.1.9': // SQL queries for v0.1.9
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Funktion <u>generateUserProfileLink()</u> mit Verlinkung auf Referral-Liste implementiert.");
				break;

			case '0.2.0': // SQL queries for v0.2.0
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_rallye_data` ADD `min_users` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_rallye_data` ADD `min_prices` BIGINT(20) UNSIGNED NOT NULL DEFAULT 3");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Ablaufen der Rallyes intergriert. Bauen Sie in Ihr Template <strong>templates/de/emails/member/member_rallye_notify.tpl</strong> folgende zwei Zeilen ein:<br />
<ul>
  <li>&#36;DATA&#91;min_users&#93;</li>
  <li>&#36;DATA&#91;min_prices&#93;</li>
</ul>
Zudem sollten Sie mindestens folgende Templates (in <strong>templates/".getLanguage()."/html/guest/</strong> !) aktualisieren:<br />
<ul>
  <li><strong>guest_rallye_footer.tpl</strong></li>
  <li><strong>guest_rallye_header.tpl</strong></li>
</ul>");
				break;

			case '0.2.1': // SQL queries for v0.2.1
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("W&ouml;rter <strong>{?mt_word?}</strong>, <strong>{?mt_word2?}</strong> und <strong>{?mt_word3?}</strong> sind austauschbar.");
				break;

			case '0.2.2': // SQL queries for v0.2.2
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Links wegen <strong>what=admins_contct</strong> ge&auml;ndert.");
				break;

			case '0.2.3': // SQL queries for v0.2.3
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("HTML-Code ausgelagert in Templates und SQL-Anweisungen abgesichert.");
				break;

			case '0.2.4': // SQL queries for v0.2.4
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Abspeichern von Einstellungen repariert.");
				break;

			case '0.2.5': // SQL queries for v0.2.5
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Men&uuml;punkt &quot;Rallyes verwalten&quot; repariert.");
				break;

			case '0.2.6': // SQL queries for v0.2.6
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Automatisches Starten von Referral-Rallyes repariert.");
				break;

			case '0.2.7': // SQL queries for v0.2.7
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fatalen Fehler beseitigt.");
				break;

			case '0.2.8': // SQL queries for v0.2.8
				// Update notes (these will be set as task text!)

				setExtensionUpdateNotes("Vorbereitung auf die neue Mediendaten v0.0.4.");
				break;

			case '0.2.9': // SQL queries for v0.2.9
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Sicherheitsupdate f&uuml;r die Include-Befehle.");
				break;

			case '0.3.0': // SQL queries for v0.3.0
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("if-Anweisungen auf Funktion <strong>empty()</strong> umgestellt.");
				break;

			case '0.3.1': // SQL queries for v0.3.1
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Erweiterung f&uuml;r automatisch generierte Admin-Kontaktlinks ge&auml;ndert.");
				break;

			case '0.3.2': // SQL queries for v0.3.2
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `action`='rals',`title`='Referral-Rallye',`sort`=1 WHERE `what`='rallyes' LIMIT 1");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Mitgliedsmen&uuml; komplett umgebaut.");
				break;

			case '0.3.3': // SQL queries for v0.3.3
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Rallyes werden nun nur dann automatisch beseitigt, wenn die Erweiterung <strong>autopurge</strong> installiert und aktiviert ist.");
				break;

			case '0.3.4': // SQL queries for v0.3.4
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehlerhinweis bei deaktivierter Erweiterung verbessert.");
				break;

			case '0.3.5': // SQL queries for 0.3.5
				// This update depends on ext-sql_patches
				addExtensionDependency('sql_patches');

				// Register filter
				registerFilter(__FILE__, __LINE__, 'extra_autopurge', 'RALLYE_EXTRA_AUTOPURGE', false, true, isExtensionDryRun());

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Filter hinzugef&uuml;gt und ist von <strong>sql_patches</strong> abh&auml;ngig.");
				break;

			case '0.3.6': // SQL queries for v0.3.6
				// Register points data
				registerExtensionPointsData('rallye_winner', 'points', 'LOCKED', 'DIRECT');

				// This depends on ext-sql_patches
				addExtensionDependency('sql_patches');

				// Update notes
				setExtensionUpdateNotes("Gewinn aus der Referral-Rallye wird nun &uuml;ber die Tabelle <strong>{OPEN_CONFIG}_MYSQL_PREFIX{CLOSE_CONFIG}_points_data</strong> verwaltet.");
				break;

			case '0.3.7': // SQL queries for v0.3.7
				// Register filter
				registerFilter(__FILE__, __LINE__, 'init', 'RALLYE_NOTIFY_USERS', false, true, isExtensionDryRun());
				registerFilter(__FILE__, __LINE__, 'add_rallye_notify_sqls', 'ADD_RALLYE_SQL_COLUMNS', false, true, isExtensionDryRun());

				// Update notes
				setExtensionUpdateNotes("Weitere Filter hinzugef&uuml;gt.");
				break;
		} // END - switch
		break;

	case 'modify': // When the extension got modified
		break;

	case 'test': // For testing purposes
		break;

	case 'init': // Do stuff when extension is initialized
		break;

	default: // Unknown extension mode
		logDebugMessage(__FILE__, __LINE__, sprintf("Unknown extension mode %s in extension %s detected.", getExtensionMode(), getCurrentExtensionName()));
		break;
} // END - switch

// [EOF]
?>
