<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 08/21/2004 *
 * ===================                          Last change: 12/04/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-sql_patches.php                              *
 * -------------------------------------------------------------------- *
 * Short description : SQL fixes for pro versions                       *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Ausgelagertes "Profildaten aendern"              *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2012 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Version number
setThisExtensionVersion('0.9.0');

// Version history array (add more with , '0.0.1' and so on)
setExtensionVersionHistory(array('0.0.0', '0.0.1', '0.0.2', '0.0.3', '0.0.4', '0.0.5', '0.0.6', '0.0.7', '0.0.8', '0.0.9', '0.1.0', '0.1.1', '0.1.2', '0.1.3', '0.1.4', '0.1.5', '0.1.6', '0.1.7', '0.1.8', '0.1.9', '0.2.0', '0.2.1', '0.2.2', '0.2.3', '0.2.4', '0.2.5', '0.2.6', '0.2.7', '0.2.8', '0.2.9', '0.3.0', '0.3.1', '0.3.2', '0.3.3', '0.3.4', '0.3.5', '0.3.6', '0.3.7', '0.3.8', '0.3.9', '0.4.0', '0.4.1', '0.4.2', '0.4.3', '0.4.4', '0.4.5', '0.4.6', '0.4.7', '0.4.8', '0.4.9', '0.5.0', '0.5.1', '0.5.2', '0.5.3', '0.5.4', '0.5.5', '0.5.6', '0.5.7', '0.5.8', '0.5.9', '0.6.0', '0.6.1', '0.6.2', '0.6.3', '0.6.4', '0.6.4', '0.6.5', '0.6.6', '0.6.7', '0.6.8', '0.6.9', '0.7.0', '0.7.1', '0.7.2', '0.7.3', '0.7.4', '0.7.5', '0.7.6', '0.7.7', '0.7.8', '0.7.9', '0.8.0', '0.8.1', '0.8.2', '0.8.3', '0.8.4', '0.8.5', '0.8.6', '0.8.7', '0.8.8', '0.8.9', '0.9.0'));

// Keep this extension always active!
setExtensionAlwaysActive('Y');

switch (getExtensionMode()) {
	case 'register': // Do stuff when installation is running
		// This depends on ext-cache now
		addExtensionDependency('cache');
		break;

	case 'remove': // Do stuff when removing extension
		// Drop tables
		addDropTableSql('admin_menu_las');
		addDropTableSql('admin_menu_las_data');
		addDropTableSql('admin_las_stats');
		addDropTableSql('dns_cache');

		// Delete admin menu entries
		addExtensionSql("DELETE LOW_PRIORITY FROM
	`{?_MYSQL_PREFIX?}_admin_menu`
WHERE
	`what`
IN (
	'config_extensions',
	'config_home',
	'list_unconfirmed',
	'config_refid',
	'config_title',
	'config_admin',
	'config_proxy',
	'config_session',
	'list_filter',
	'list_point_accounts'
)");

		// Delete/update member menu entries
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE
`what`='stats2' OR
`what`='reflist' OR
(`action`='stats' AND (`what`='' OR `what` IS NULL)) OR
(`action`='extras' AND (`what`='' OR `what` IS NULL)) OR
(`action`='rals' AND (`what`='' OR `what` IS NULL)) OR
(`action`='account' AND (`what`='' OR `what` IS NULL)) OR
`action`='earn'");
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `action`='main' WHERE
`action`='stats' OR
`action`='extras' OR
`action`='rals' OR
`action`='account'");

		// Remove points data
		unregisterExtensionPointsData('pool_payback');
		unregisterExtensionPointsData('mail_deleted');
		unregisterExtensionPointsData('admin_add_single');
		unregisterExtensionPointsData('admin_add_single_ref');
		unregisterExtensionPointsData('admin_add_all');
		unregisterExtensionPointsData('admin_add_all_ref');

		// Unregister filter
		unregisterFilter(__FILE__, __LINE__, 'member_login_check', 'RESET_USER_LOGIN_FAILURE', true, isExtensionDryRun());
		unregisterFilter(__FILE__, __LINE__, 'add_history_entry', 'ADD_HISTORY_ENTRY', true, isExtensionDryRun());
		unregisterFilter(__FILE__, __LINE__, 'init', 'GENERATE_FILE_SECRET_HASH', true, isExtensionDryRun());
		break;

	case 'activate': // Do stuff when admin activates this extension
		// SQL commands to run
		addExtensionSql('');
		break;

	case 'deactivate': // Do stuff when admin deactivates this extension
		// SQL commands to run
		addExtensionSql('');
		break;

	case 'update': // Update an extension
		switch (getCurrentExtensionVersion()) {
			case '0.0.1': // SQL queries for v0.0.1
				addAdminMenuSql('setup', 'config_extensions', 'Erweitungsmanagement', 'Alle Einstellungen am Erweiterungsmanagement.', 10);

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Es kann nun bestimmt werden, ob vom Server gel&ouml;schte ext-xxx.php erkannt werden sollen und die verkn&uuml;pften Daten auch aus der Datenbank entfernt werden sollen.");
				break;

			case '0.0.2': // SQL queries for v0.0.2
				addConfigChangeSql('auto_purge', 'auto_purge', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT ' . (getOneDay()*14));

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("In der Tabelle <strong>{?_MYSQL_PREFIX?}_config</strong> musste die Spalte <strong>auto_purge</strong> (autom. L&ouml;schen von Best&auml;tigungsmails angepasst werden (war auf dem Testsystem auf TINYINT(4) gesetzt.)");
				break;

			case '0.0.3': // SQL queries for v0.0.3
				addConfigAddSql('points_word', "VARCHAR(255) NOT NULL DEFAULT '{OPEN_TEMPLATE}DEFAULT_POINTS{CLOSE_TEMPLATE}'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Das Wort &quot;Punkte&quot; kann nun per Datenbank ge&auml;ndert werden. Damit k&ouml;nnen anstelle des Wortes Punkte auch Klammlose, Wernis, Primera und auch &euro; geschrieben werden.");
				break;

			case '0.0.4': // SQL queries for v0.0.4
				addConfigAddSql('mails_page', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT 10');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Anzahl Mails pro Seite in <strong>EMail-Details ansehen</strong> und <strong>EMail-Archiv</strong> hinzugef&uuml;gt.");
				break;

			case '0.0.5': // SQL queries for v0.0.5
				addConfigAddSql('index_home', "VARCHAR(255) NOT NULL DEFAULT 'welcome'");
				addAdminMenuSql('setup','config_home','Home-Seite festlegen','Stellen Sie hier ein, welcher Men&uuml;punkt (what-welcome ist Standard) als Einstiegspunkt in das Men&uuml;system genutzt werden soll.', 5);

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Die what-welcome.php ist derzeit die &quot;Home&quot;-Seite (Eingangsseite). Dies kann nun per Datenbank ge&auml;ndert werden.");
				break;

			case '0.0.6': // SQL queries for v0.0.6
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_extensions` ADD `ext_has_css` ENUM('Y','N') NOT NULL DEFAULT 'Y'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Es k&ouml;nnen nun SQL-Updates von einander abh&auml;ngig gemacht werden und die CSS-Datei kann per Admin-Bereich (wegen Debuggings) ein- bzw. ausgeschaltet werden.");
				break;

			case '0.0.7': // SQL queries for v0.0.7
				addConfigAddSql('verbose_sql', "ENUM('Y','N') NOT NULL DEFAULT 'Y'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Die SQL-Anweisungen werden bei eingeschalteter Verbose-Funktion detailiert angezeigt.");
				break;

			case '0.0.8': // SQL queries for v0.0.8
				addConfigAddSql('menu_blur_spacer', "VARCHAR(255) NOT NULL DEFAULT '&nbsp;<strong><big>&middot;</big></strong>&nbsp;'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Nette Mouse-Hover-Effekte eingebaut (Anleitung <strong>MENUE_HOVER.txt</strong> zum Patchen der general.css bitte lesen!)");
				break;

			case '0.0.9': // SQL queries for v0.0.9
				addAdminMenuSql('email','list_unconfirmed','Unbest. Mails auflisten','Schauen Sie sich hier unbest&auml;tigte Maillinks an. Bitte diesen Link nur &uuml;ber dem EMail-Archiv oder EMail-Details aufrufen, direkt aufgerufen bekommen Sie eine Fehlermeldung.', 8);

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Unbest&auml;tigte Maillinks k&ouml;nnen unter Email-Management -&gt; Unbest. Mails auflisten aufgelistet werden.");
				break;

			case '0.1.0': // SQL queries for v0.1.0
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Soll der einmalige Ref-Bonus &uuml;ber das Referral-System (also alle oberen Refs bekommen auch etwas davon ab) oder direkt dem Werber aufgebucht werden?");
				break;

			case '0.1.1': // SQL queries for v0.1.1
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_admin_menu` SET `title`='Home-/Eingangsseite', descr='Stellen Sie hier ein, welcher Men&uuml;punkt (what-welcome ist Standard) als Einstiegspunkt in das Men&uuml;system genutzt werden soll und wie die automatische Weiterleitung in der Eingangsseite funktionieren soll.' WHERE `what`='config_home' LIMIT 1");
				addConfigAddSql('index_delay', 'TINYINT(3) NOT NULL DEFAULT 0');
				addConfigAddSql('index_cookie', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT ' . (getOneDay() * 365));

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Sie k&ouml;nnen nun <a href=\"{%url=modules.php?module=admin&amp;what=config_home%}\">hier</a> die Verz&ouml;gerungszeit in der <a href=\"{%url=index.php%}\">Eingangsseite</a> einstellen.");
				break;

			case '0.1.2': // SQL queries for v0.1.2
				addAdminMenuSql('setup','config_refid','Standard-Ref-Id','Stellen Sie hier die Mitglied-Id ein, die genommen werden soll, wenn der Gast n icht per Referral-Link Ihren {?mt_word?} aufgerufen hat.', 7);
				addConfigAddSql('def_refid', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT 0');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Standard Referral-Id kann per Admin-Bereich eingestellt werden (war vorher nur in modules.php und index.php direkt eingebbar.)");
				break;

			case '0.1.3': // SQL queries for v0.1.3
				addConfigAddSql('refid_target', "ENUM('register','index') NOT NULL DEFAULT 'register'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Auf welche Seite soll der Ref-Link zeigen? Eingangsseite oder Anmeldeformular?");
				break;

			case '0.1.4': // SQL queries for v0.1.4
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Ung&uuml;ltiges Update (nach ext-theme.php verschoben!).");
				break;

			case '0.1.5': // SQL queries for v0.1.5
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_extensions` DROP `ext_has_admin`");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Spalte <u>ext_has_admin</u> aus der Tabelle <u>{?_MYSQL_PREFIX?}_extensions</u> entfernt, da sie keinen Sinn mehr macht.");
				break;

			case '0.1.6': // SQL queries for v0.1.6
				addConfigAddSql('enable_title_deco', "ENUM('Y','N') NOT NULL DEFAULT 'Y'");
				addConfigAddSql('title_left', "VARCHAR(10) NOT NULL DEFAULT '[--'");
				addConfigAddSql('title_middle', "VARCHAR(10) NOT NULL DEFAULT '-'");
				addConfigAddSql('title_right', "VARCHAR(10) NOT NULL DEFAULT '--]'");
				addConfigAddSql('enable_mod_title', "ENUM('Y','N') NOT NULL DEFAULT 'Y'");
				addConfigAddSql('enable_what_title', "ENUM('Y','N') NOT NULL DEFAULT 'Y'");
				addAdminMenuSql('setup','config_title','Seitentitel &auml;ndern','De-/aktivieren Sie hier die Dekorationen, sowie Modul-Titel und what-Titel im Seitentitel.', 8);

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Dekorationen des Seitentiteles lassen sich ein- und ausschalten und selber definieren; Modul-Titel und Titel der <strong>what</strong>-Dateien kann hinzugef&uuml;gt werden.");
				break;

			case '0.1.7': // SQL queries for v0.1.7
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.");
				break;

			case '0.1.8': // SQL queries for v0.1.8
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("mad_count und last_mad werden nun aus der Datenbank geladen");
				break;

			case '0.1.9': // SQL queries for v0.1.9
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.");
				break;

			case '0.2.0': // SQL queries for v0.2.0
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_jackpot` CHANGE `points` `points` FLOAT(20,5) UNSIGNED NOT NULL DEFAULT 0.00000");

				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_payments` CHANGE `payment` `payment` FLOAT(20,5) UNSIGNED NOT NULL DEFAULT 0.00000");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_payments` CHANGE `price` `price` FLOAT(20,5) UNSIGNED NOT NULL DEFAULT 0.00000");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("5 Nachkommastellen implementiert");
				break;

			case '0.2.1': // SQL queries for v0.2.1
				addConfigAddSql('css_php', "ENUM('DIRECT','FILE') NOT NULL DEFAULT 'FILE'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Ausgabe der CSS-Dateien entweder per css.php oder sie sind direkt eingebunden.");
				break;

			case '0.2.2': // SQL queries for v0.2.2
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Erweiterung bleibt wegen integrierten Schalters immer aktiv.");
				break;

			case '0.2.3': // SQL queries for v0.2.3
				addConfigAddSql('guest_menu', "ENUM('Y','N') NOT NULL DEFAULT 'Y'");
				addConfigAddSql('member_menu', "ENUM('Y','N') NOT NULL DEFAULT 'Y'");
				addConfigAddSql('youre_here', "ENUM('Y','N') NOT NULL DEFAULT 'Y'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Gast- und Mitgliedsmen&uuml;s lassen sich getrennt voneinander abschalten.");
				break;

			case '0.2.4': // SQL queries for v0.2.4
				// PNG image is the default
				$auto_type = 'png';

				// Is the JPEG file found and required PHP function there?
				if ((!isFileReadable(getPath() . 'theme/' . getCurrentTheme() . '/images/code_bg.png')) || (!function_exists('imagecreatefrompng'))) {
					// Switch to JPEG format because PNG is not available
					$auto_type = 'jpg';
				} // END - if
				addConfigAddSql('img_type', "ENUM('jpg','png') NOT NULL DEFAULT '" . $auto_type . "'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Generierung des Mailbest&auml;tigungscodes h&auml;ngt davon ab, ob die PHP-Funktion <u>imagecreatefromjpeg()</u> und das JPEG-Bild vorhanden sind oder nicht.");
				break;

			case '0.2.5': // SQL queries for v0.2.5
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Spalten <u>max_mails</u> und <u>receive_mails</u> auf BIGINT(20) gesetzt.");
				break;

			case '0.2.6': // SQL queries for v0.2.6
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Verschoben nach <strong>ext-user</strong>.");
				break;

			case '0.2.7': // SQL queries for v0.2.7
				addConfigAddSql('stats_limit', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT 10');
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_admin_menu` SET `what`='config_stats' WHERE `what`='stats' LIMIT 1");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("<ol>
<li>Das Mitglied kann das derzeitige Design in sein Profil abspeichern.</li>
<li>Mitgliederstatistik mit Seitennavigation.</li>
</ol>");
				break;

			case '0.2.8': // SQL queries for v0.2.8
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Nicht mehr g&uuml;ltiges Update.");
				break;

			case '0.2.9': // SQL queries for v0.2.9
				addConfigAddSql('mt_word', "VARCHAR(255) NOT NULL DEFAULT 'Mailtausch'");
				addConfigAddSql('mt_word2', "VARCHAR(255) NOT NULL DEFAULT 'Mailtausches'");
				addConfigAddSql('mt_word3', "VARCHAR(255) NOT NULL DEFAULT 'Mailtauscher'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("W&ouml;rter <strong>{?mt_word?}</strong>, <strong>{?mt_word2?}</strong> und <strong>{?mt_word3?}</strong> sind austauschbar.");
				break;

			case '0.3.0': // SQL queries for v0.3.0
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_admin_menu` SET `title`='{OPEN_CONFIG}POINTS{CLOSE_CONFIG}/Referral-Ebenen' WHERE `what`='config_points' LIMIT 1");
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_admin_menu` SET `title`='Mailverg&uuml;tungen...' WHERE `what`='payments' LIMIT 1");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Zwei Men&uuml;punkte umbenannt.");
				break;

			case '0.3.1': // SQL queries for v0.3.1
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_extensions` ADD UNIQUE INDEX `ext_name` (`ext_name`)");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_admins` ADD UNIQUE INDEX `login` (`login`)");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_refbanner` ADD INDEX `visible` (`visible`)");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_refdepths` ADD UNIQUE INDEX `level` (`level`)");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_refsystem` ADD INDEX `level` (`level`)");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_pool` ADD INDEX `data_type` (`data_type`)");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_mod_reg` ADD UNIQUE INDEX `module` (`module`)");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_admin_menu` ADD INDEX `action` (`action`)");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_admin_menu` ADD INDEX `what` (`what`)");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_task_system` ADD INDEX `task_type` (`task_type`)");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_task_system` ADD INDEX `status` (`status`)");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_task_system` ADD INDEX `task_created` (`task_created`)");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_task_system` ADD FULLTEXT `subject` (`subject`)");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_task_system` ADD INDEX `subject` (`subject`)");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_extensions` ADD INDEX `ext_active` (`ext_active`)");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_guest_menu` ADD INDEX `action` (`action`)");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_guest_menu` ADD INDEX `what` (`what`)");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_guest_menu` ADD INDEX `sort` (`sort`)");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_guest_menu` ADD INDEX `visible` (`visible`)");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_guest_menu` ADD INDEX `locked` (`locked`)");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_member_menu` ADD INDEX `what` (`what`)");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_member_menu` ADD INDEX `sort` (`sort`)");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_member_menu` ADD INDEX `visible` (`visible`)");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_member_menu` ADD INDEX `locked` (`locked`)");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_cats` ADD INDEX `visible` (`visible`)");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_cats` ADD INDEX `sort` (`sort`)");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Eindeutige Schl&uuml;ssel (UNIQUE) und normale Schl&uuml;ssel (INDEX) gesetzt.");
				break;

			case '0.3.2': // SQL queries for v0.3.2
				// Connection table between the menu system and the "logical area system"
				addDropTableSql('admin_menu_las');
				addCreateTableSql('admin_menu_las', "
`id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`la_id` VARCHAR(255) NOT NULL DEFAULT '',
`la_action` VARCHAR(255) NOT NULL DEFAULT '',
`la_what` VARCHAR(255) NOT NULL DEFAULT '',
PRIMARY KEY (`id`),
INDEX (`la_id`),
INDEX (`la_action`),
INDEX (`la_what`)",
					'Menu system -> LAS');

				// All "logical areas" together
				addDropTableSql('admin_menu_las_data');
				addCreateTableSql('admin_menu_las_data', "
`id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`la_id` VARCHAR(255) NOT NULL DEFAULT '',
`la_title` VARCHAR(255) NOT NULL DEFAULT '',
`la_posx` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`la_posy` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
PRIMARY KEY (`id`),
UNIQUE (`la_id`),
INDEX (`la_posx`),
INDEX (`la_posy`)",
					'LAS position and title data');

				// Which menu do you like?
				addConfigAddSql('admin_menu', "ENUM('NEW','OLD') NOT NULL DEFAULT 'OLD'");

				// Insert menus
				addAdminMenuSql('setup', 'config_admin', 'Adminmen&uuml;', 'Diverse Einstellungen am Adminmen&uuml; vornehmen.', 9);

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Logische Bereiche (Logical Areas = LAs) eingef&uuml;hrt. Dadurch wird das immer st&auml;rker anwachsende Admin-Men&uuml; in grosse Hauptgruppen unterteilt, wodurch ein Auffinden von Men&uuml;punkten verbessert wird.");
				break;

			case '0.3.3': // SQL queries for v0.3.3
				// Switch of the "intelligent menu sorter" when you want to have a fixed menu structure...
				addConfigAddSql('admin_menu_sorter', "ENUM('Y','N') NOT NULL DEFAULT 'Y'");

				// The statistics table
				addDropTableSql('admin_las_stats');
				addCreateTableSql('admin_las_stats', "
`id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`admin_id` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`type` ENUM('la','action','what') NOT NULL DEFAULT 'what',
`clicks` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
PRIMARY KEY (`id`),
INDEX (`admin_id`)",
					'LAS click data');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Admin-abh&auml;ngig werden nun Klicks im Admin-Men&uuml; gez&auml;hlt, die zur automatischen Anpassung des Men&uuml;s in den logischen Bereichen diennen. Dieses &quot;intelligente Unbauen&quot; k&ouml;nnen Sie auch ganz abschalten.");
				break;

			case '0.3.4': // SQL queries for v0.3.4
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Veraltetes Update (what=list_user&amp;mode=noref)");
				break;

			case '0.3.5': // SQL queries for v0.3.5
				// List accounts with no referral
				addMemberMenuSql('stats', NULL, 'Statistiken', 4);
				addMemberMenuSql('stats', 'stats2', 'Framekiller-Mails', 2);
				addMemberMenuSql('extras', NULL, 'Extras', 5);
				addMemberMenuSql('rals', NULL, 'Rallyes', 6);
				addMemberMenuSql('account', NULL, 'Ihr Account', 7);
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `action`='stats',`sort`=1,`title`='Klick-Mails' WHERE `what`='stats' LIMIT 1");
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `action`='extras',`sort`=3 WHERE `what`='reflinks' LIMIT 1");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Mitgliedsmen&uuml; komplett umgebaut.");
				break;

			case '0.3.6': // SQL queries for v0.3.6
				addConfigAddSql('salt_length', 'TINYINT(3) UNSIGNED NOT NULL DEFAULT 10');
				addConfigAddSql('pass_scramble', "VARCHAR(255) NOT NULL DEFAULT ''");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_admins` CHANGE `password` `password` VARCHAR(255) NOT NULL DEFAULT ''");
				addConfigAddSql('rand_no', 'BIGINT(20) UNSIGNED NOT NULL DEFAULT 0');
				addConfigAddSql('file_hash', "VARCHAR(255) NOT NULL DEFAULT ''");
				addConfigAddSql('master_salt', "VARCHAR(255) NOT NULL DEFAULT ''");
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_config` SET `rand_no`=(ROUND(RAND() * 99999) + 100000) WHERE `config`=0 LIMIT 1");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_mod_reg` ADD `has_menu` ENUM('Y','N') NOT NULL DEFAULT 'N'");
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_mod_reg` SET `has_menu`='Y' WHERE `module`='admin' OR `module`='index' OR `module`='login' LIMIT 3");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Passwort-System mit Zufallshash erweitert (Schutzt gegen Dictionary-Attacks!)");
				break;

			case '0.3.7': // SQL queries for v0.3.7
				setExtensionUpdateNotes("Problem w&auml;hrend des Installationsvorganges behoben.");
				break;

			case '0.3.8': // SQL queries for v0.3.8
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_admin_menu` CHANGE `descr` `descr` MEDIUMTEXT NULL");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_pool` CHANGE `text` `text` LONGTEXT NOT NULL");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Beschreibungstexte f&uuml;r Admin-Men&uuml;s k&ouml;nnen l&auml;nger sein. Diverse Fixes.");
				break;

			case '0.3.9': // SQL queries for v0.3.9
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Beschreibungstexte f&uuml;r Admin-Men&uuml;s k&ouml;nnen l&auml;nger sein. Diverse Fixes.");
				break;

			case '0.4.0': // SQL queries for v0.4.0
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_admin_menu` SET `title` = 'Email-Management' WHERE `action` = 'email' AND (`what`='' OR `what` IS NULL) LIMIT 1");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Email-Verwaltung nach Email-Management umbenannt.");
				break;

			case '0.4.1': // SQL queries for v0.4.1
				addConfigAddSql('show_timings', "ENUM ('Y','N') NOT NULL DEFAULT 'Y'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Tabellen-Schl&uuml;ssel neu gesetzt und Parsing-Zeit im Footer eingeblendet.");
				break;

			case '0.4.2': // SQL queries for v0.4.2
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Nicht mehr g&uuml;ltiges Update.");
				break;

			case '0.4.3': // SQL queries for v0.4.3
				addConfigAddSql('proxy_host', "VARCHAR(255) NOT NULL DEFAULT ''");
				addConfigAddSql('proxy_port', 'INT(5) UNSIGNED NOT NULL DEFAULT 0');
				addConfigAddSql('proxy_username', "VARCHAR(255) NOT NULL DEFAULT ''");
				addConfigAddSql('proxy_password', "VARCHAR(255) NOT NULL DEFAULT ''");
				addAdminMenuSql('setup','config_proxy','Proxy-Einstellungen','Sollte Ihr Webserver sich hinter einem Proxy befinden, so k&ouml;nnen Sie Ihren {?mt_word?} so konfigurieren, dass es z.B. Updates, Abfragen von Netzwerkupdates &uuml;ber diesen t&auml;tigt.', 15);

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Proxy-Einstellungen hinzugef&uuml;gt.");
				break;

			case '0.4.4': // SQL queries for v0.4.4
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_admin_menu` CHANGE `what` `what` VARCHAR(255) NULL DEFAULT NULL");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_guest_menu` CHANGE `what` `what` VARCHAR(255) NULL DEFAULT NULL");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_member_menu` CHANGE `what` `what` VARCHAR(255) NULL DEFAULT NULL");
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_admin_menu` SET `what`=NULL WHERE `what`=''");
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_guest_menu` SET `what`=NULL WHERE `what`=''");
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `what`=NULL WHERE `what`=''");

				// Make this depending on ext-menu
				addExtensionDependency('menu');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Schl&uuml;ssel in Admin-, Gast- und Mitgliedsmen&uuml; verbessert.");
				break;

			case '0.4.5': // SQL queries for v0.4.5
				addConfigAddSql('last_month', 'CHAR(2) NOT NULL DEFAULT 00');
				addConfigAddSql('last_week', 'CHAR(2) NOT NULL DEFAULT 00');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("T&auml;glichen/w&ouml;chentlichen/monatlichen Reset verbessert.");
				break;

			case '0.4.6': // SQL queries for v0.4.6
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Nicht mehr g&uuml;ltiges Update.");
				break;

			case '0.4.7': // SQL queries for v0.4.7
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Veraltetes Update.");
				break;

			case '0.4.8': // SQL queries for v0.4.8
				addExtensionSql('ALTER TABLE `{?_MYSQL_PREFIX?}_task_system` ADD INDEX (`subject`)');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Index f&uuml;r Betreff eingef&uuml;gt.");
				break;

			case '0.4.9': // SQL queries for v0.4.9
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Nicht mehr g&uuml;ltiges Update.");
				break;

			case '0.5.0': // SQL queries for v0.5.0
				addExtensionSql('ALTER TABLE `{?_MYSQL_PREFIX?}_refsystem` DROP INDEX `level`');
				addExtensionSql('ALTER TABLE `{?_MYSQL_PREFIX?}_refsystem` DROP INDEX `userid`');
				addExtensionSql('ALTER TABLE `{?_MYSQL_PREFIX?}_refsystem` ADD UNIQUE INDEX `userid_level` (`userid`,`level`)');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Referral-System unterst&uuml;tzt nun detailierte Referral-&Uuml;bersicht und vieles mehr.");
				break;

			case '0.5.1': // SQL queries for v0.5.1
				addExtensionSql('ALTER TABLE `{?_MYSQL_PREFIX?}_member_menu` DROP `descr`');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Beschreibungsspalte von Mitgliedsmen&uuml; entfernt, welche ohnehin nicht genutzt wird.");
				break;

			case '0.5.2': // SQL queries for v0.5.2
				addExtensionSql('ALTER TABLE `{?_MYSQL_PREFIX?}_refdepths` CHANGE `percents` `percents` FLOAT(8,5) UNSIGNED NOT NULL DEFAULT 0.00000');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Prozents&auml;tze k&ouml;nnen nun f&uuml;nf Stellen hinter dem Komma sein.");
				break;

			case '0.5.3': // SQL queries for v0.5.3
				addConfigAddSql('session_save_path', "VARCHAR(255) NOT NULL DEFAULT ''");
				addAdminMenuSql('setup','config_session','Session-Einstellungen','&Auml;ndern Sie hier den Speicherpfad f&uuml;r Sessiondateien (Sitzungsdateien) ab, falls die Standard-Einstellung bei Ihrem Hoster zu Problem f&uuml;hren sollte.', 16);

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Session-Speicherpfad konfigurierbar. Beispielsweise ist dies bei all-inkl.com n&ouml;tig.");
				break;

			case '0.5.4': // SQL queries for v0.5.4
				addMemberMenuSql('main', 'reflist', 'Ref-&Uuml;bersicht', 5);

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Ref-&Uuml;bersicht eingebaut. Diese h&auml;ngt von der Erweiterung <strong>refback</strong> ab.");
				break;

			case '0.5.5': // SQL queries for v0.5.5
				addConfigAddSql('show_points_unconfirmed', "ENUM('Y','N') NOT NULL DEFAULT 'Y'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Anzeige der {?POINTS?} unter den unbest&auml;tigten Mails kann nun optional abgeschaltet werden.");
				break;

			case '0.5.6': // SQL queries for v0.5.6
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Nicht mehr g&uuml;ltiges Update.");
				break;

			case '0.5.7': // SQL queries for v0.5.7
				addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_admin_menu` WHERE `what`='list_norefs' LIMIT 1");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Auflistung der Mitglieder ohne Werber nach what=list_user&amp;mode=norefs verschoben.");
				break;

			case '0.5.8': // SQL queries for v0.5.8
				addExtensionSql('ALTER TABLE `{?_MYSQL_PREFIX?}_extensions` DROP `ext_lang_file`');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Sprachdateinamen werden nicht mehr in der Datenbank behalten.");
				break;

			case '0.5.9': // SQL queries for v0.5.9
				// Table 'filters' is vital because many functionality depends on it, so don't remove it
				addCreateTableSql('filters', "
`filter_id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`filter_name` VARCHAR(50) NOT NULL DEFAULT '',
`filter_function` VARCHAR(100) NOT NULL DEFAULT '',
`filter_active` ENUM('N','Y') NOT NULL DEFAULT 'Y',
`filter_counter` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
PRIMARY KEY (`filter_id`),
UNIQUE INDEX `name_function` (`filter_name`,`filter_function`)",
					'Filter system');

				// Admin menu
				addAdminMenuSql('setup','list_filter','Filter-Management', 'Zeigt alle im System registrierten Filter an und l&auml;sst diese de- bzw. wieder aktivieren.', 17);

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Tabellen f&uuml;r Filter-System hinzugef&uuml;gt.");
				break;

			case '0.6.0': // SQL queries for v0.6.0
				addConfigAddSql('update_filter_usage', "ENUM('N','Y') NOT NULL DEFAULT 'N'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Benutzungsstatistik eingebaut. Das Z&auml;hlen der Filterverwendungen sollte <strong>ausschliesslich</strong> zu Debugging-Zwecken eingesetzt werden.");
				break;

			case '0.6.1': // SQL queries for v0.6.1
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Nicht mehr g&uuml;ltiges Update.");
				break;

			case '0.6.2': // SQL queries for v0.6.2
				// Depends on refback extension
				addExtensionDependency('user');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Abh&auml;ngigkeit von <u>ext-user</u> gesetzt.");
				break;

			case '0.6.3': // SQL queries for v0.6.3
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Filter-Tabelle bereinigt um doppelte Eintr&auml;ge und Unique-Key auf <span class=\"bad\">filter_name</span> und <span class=\"bad\">filter_function</span> zusammen gesetzt.");

				// Add special fix include to fix filters
				addIncludeToPool('extension', 'inc/fix_filters.php');
				break;

			case '0.6.4': // SQL queries for v0.6.4
				// Update admin menu
				addExtensionSql("UPDATE  `{?_MYSQL_PREFIX?}_admin_menu` SET `title` = REPLACE(`title`, '!POINTS!', '?POINTS?') WHERE `title` LIKE '%!POINTS!%'");
				addExtensionSql("UPDATE  `{?_MYSQL_PREFIX?}_admin_menu` SET `descr` = REPLACE(`descr`, '!POINTS!', '?POINTS?') WHERE `descr` LIKE '%!POINTS!%'");
				addExtensionSql("UPDATE  `{?_MYSQL_PREFIX?}_guest_menu` SET `title` = REPLACE(`title`, '!POINTS!', '?POINTS?') WHERE `title` LIKE '%!POINTS!%'");
				addExtensionSql("UPDATE  `{?_MYSQL_PREFIX?}_member_menu` SET `title` = REPLACE(`title`, '!POINTS!', '?POINTS?') WHERE `title` LIKE '%!POINTS!%'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Datenbank umgestellt auf Konfigurationselemente.");
				break;

			case '0.6.5': // SQL queries for v0.6.5
				addConfigChangeSql('css_php', 'css_php', "ENUM('DIRECT','FILE','INLINE') NOT NULL DEFAULT 'FILE'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Ausgabe der CSS-Dateien entweder per css.php oder sie sind direkt eingebunden.");
				break;

			case '0.6.6': // SQL queries for v0.6.6
				addAdminMenuSql('setup', 'config_secure', 'Sicherheitseinstellungen', 'Stellen Sie ein, wie lange das Passwort eines Mitgliedes mindestens sein muss uvm.', 9);
				addAdminMenuSql('setup', 'config_points', '{OPEN_CONFIG}POINTS{CLOSE_CONFIG}', 'Stellen Sie hier die Willkommensgutschrift, Referral-Gutschrift (einmalige) usw. ein.', 10);
				addAdminMenuSql('email', 'email_archiv', 'E-Mail Archiv', 'Sehen Sie sich hier bereits gesendete Mails an.', 6);

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Die Sicherheitseinstellungen, {?POINTS?}-Einstellungen und Email-Archiv funktionieren nur, wenn diese Erweiterung installiert ist.");
				break;

			case '0.6.7': // SQL queries for v0.6.7
				addConfigChangeSql('index_delay', 'index_delay', 'TINYINT(3) NOT NULL DEFAULT 0');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Die Weiterleitungseinstellung muss auch Werte kleiner Null akzeptieren.");
				break;

			case '0.6.8': // SQL queries for v0.6.8
				addExtensionSql('ALTER TABLE `{?_MYSQL_PREFIX?}_admin_menu` CHANGE `action` `action` VARCHAR(50) NOT NULL');
				addExtensionSql('ALTER TABLE `{?_MYSQL_PREFIX?}_admin_menu` CHANGE `what` `what` VARCHAR(50) NULL DEFAULT NULL');
				addExtensionSql('ALTER TABLE `{?_MYSQL_PREFIX?}_guest_menu` CHANGE `action` `action` VARCHAR(50) NOT NULL');
				addExtensionSql('ALTER TABLE `{?_MYSQL_PREFIX?}_admin_menu` CHANGE `what` `what` VARCHAR(50) NULL DEFAULT NULL');
				addExtensionSql('ALTER TABLE `{?_MYSQL_PREFIX?}_member_menu` CHANGE `action` `action` VARCHAR(50) NOT NULL');
				addExtensionSql('ALTER TABLE `{?_MYSQL_PREFIX?}_admin_menu` CHANGE `what` `what` VARCHAR(50) NULL DEFAULT NULL');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Spalten verk&uuml;rzt, damit die Schl&uuml;ssel passen.");
				break;

			case '0.6.9': // SQL queries for 0.6.9
				// Register filter
				registerFilter(__FILE__, __LINE__, 'member_login_check', 'RESET_USER_LOGIN_FAILURE', false, true, isExtensionDryRun());

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Filter zum Zur&uuml;cksetzens des fehlgeschlagenen Mitgliederlogins hinzugef&uuml;gt (internes TODO).");
				break;

			case '0.7.0': // SQL queries for 0.7.0
				// Table definition
				addDropTableSql('dns_cache');
				addCreateTableSql('dns_cache', "
`hostname` VARCHAR(255) NOT NULL,
`ip` VARCHAR(15) NOT NULL,
`added` DATETIME NOT NULL,
PRIMARY KEY (`hostname`),
INDEX (`ip`)",
					'Cache for DNS requests');

				// Configuration
				addConfigAddSql('dns_cache_timeout', 'BIGINT(20) NOT NULL DEFAULT ' . (60*60*24));

				// Register filter
				registerFilter(__FILE__, __LINE__, 'reset', 'CLEANUP_DNS_CACHE', false, true, isExtensionDryRun());

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("IP-Resolver-Klasse hinzugef&uuml;gt, um bei der Erweiterung ext-network DNS-Anfragen einzusparen.");
				break;

			case '0.7.1': // SQL queries for v0.7.1
				// This update just depends on ext-timezone to make integration of an essential extension much easier
				addExtensionDependency('timezone');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Zeitzone ist nun mit ext-timezone konfigurierbar.");
				break;

			case '0.7.2': // SQL queries for v0.7.2
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_task_system` SET `task_type`='MEMBER_SUPPORT' WHERE `task_type`='SUPPORT_MEMBER'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Daten an Namenskonvention angepasst.");
				break;

			case '0.7.3': // SQL queries for v0.7.3
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_filters` CHANGE `filter_name` `filter_name` VARCHAR(50) NOT NULL DEFAULT ''");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_filters` CHANGE `filter_function` `filter_function` VARCHAR(100) NOT NULL DEFAULT ''");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Spalten in Filtertabelle gek&uuml;rzt (SQL-Fehler wegen zu grossem Schl&uuml;ssel).");
				break;

			case '0.7.4': // SQL queries for v0.7.4
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_pool` ADD `mails_sent` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Spalten in Filtertabelle gek&uuml;rzt (SQL-Fehler wegen zu grossem Schl&uuml;ssel).");
				break;

			case '0.7.5': // SQL queries for v0.7.5
				addConfigAddSql('last_hour', 'TINYINT(2) UNSIGNED ZEROFILL NOT NULL DEFAULT 00');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Aktuelle Stunde hinzugef&uuml;gt (ist nicht konfigurierbar).");
				break;

			case '0.7.6': // SQL queries for v0.7.6
				addConfigChangeSql('last_month', 'last_month', 'TINYINT(2) UNSIGNED ZEROFILL NOT NULL DEFAULT 00');
				addConfigChangeSql('last_week', 'last_week', 'TINYINT(2) UNSIGNED ZEROFILL NOT NULL DEFAULT 00');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Spaltentyp fuer kleine Zahlen sollten auch z.B. TINYINT sein.");
				break;

			case '0.7.7': // SQL queries for v0.7.7
				addMemberMenuSql('earn', NULL, 'Verdienen', 2);
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `action`='earn',`sort`=1 WHERE `what`='unconfirmed' LIMIT 1");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Men&uuml;punkt <strong>Verdienen</strong> hinzugef&uuml;gt und <strong>Unbest&auml;tigte Mails</strong> als ersten Punkt dort hin verschoben.");
				break;

			case '0.7.8': // SQL queries for v0.7.8
				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Konfigurationseintr&auml;ge mit Spaltentyp <strong>ENUM</strong> werden nun immer komplett gross geschrieben.");
				break;

			case '0.7.9': // SQL queries for v0.7.9
				addExtensionSQL("UPDATE `{?_MYSQL_PREFIX?}_admin_menu` SET `what`='list_email_max_rec' WHERE `what`='config_email' LIMIT 1");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Adminscript <strong>what-config_email.php</strong> nach <strong>what-list_email_max_rec.php</strong> umbenannt.");
				break;

			case '0.8.0': // SQL queries for v0.8.0
				// Points account data (this table should not be dropped or else you may have to re-install a lot extensions)
				addCreateTableSql('points_data', "
`id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`subject` VARCHAR(255) NOT NULL DEFAULT '',
`column_name` VARCHAR(255) NOT NULL DEFAULT 'points',
`locked_mode` ENUM('LOCKED','UNLOCKED') NOT NULL DEFAULT 'LOCKED',
`payment_method` ENUM('DIRECT','REFERRAL') NOT NULL DEFAULT 'REFERRAL',
`notify_recipient` ENUM('Y','N') NOT NULL DEFAULT 'N',
PRIMARY KEY (`id`),
UNIQUE KEY (`subject`)",
					'Points account data');

				// Admin menu
				addAdminMenuSql('setup', 'list_point_accounts', 'Guthabenkonten...', 'Veralten Sie hier bequem Einstellungen zu den Guthabenkonten.', 5);

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Tabelle <span class=\"bad\">points_data</span> erzeugt, diese soll das {?POINTS?}-Guthaben komplett lenken.");
				break;

			case '0.8.1': // SQL queries for v0.8.1
				addExtensionSql('ALTER TABLE `{?_MYSQL_PREFIX?}_refdepths` CHANGE `level` `level` TINYINT(3) UNSIGNED NULL DEFAULT NULL');
				addExtensionSql('UPDATE `{?_MYSQL_PREFIX?}_refdepths` SET `level`=NULL WHERE `level`=0 LIMIT 1');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Level 0 ist nun auch NULL.");
				break;

			case '0.8.2': // SQL queries for v0.8.2
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_points_data` DROP INDEX `ext_name`");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_points_data` CHANGE `ext_name` `subject` VARCHAR(255) NOT NULL DEFAULT ''");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_points_data` ADD INDEX `subject` (`subject`)");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_points_data` ADD `notify_recipient` ENUM('Y','N') NOT NULL DEFAULT 'N'");

				// Register points data
				registerExtensionPointsData('pool_payback', 'points', 'LOCKED', 'DIRECT');
				registerExtensionPointsData('mail_deleted', 'points', 'LOCKED', 'DIRECT');

				// Remove deprecated configuration entry
				addConfigDropSql('reg_points_mode');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Es sollte der Gutschriftenbetreff und nicht der Erweiterungsname gepeichert werden, zudem brauchen wir einen Konfigurationseintrag nicht mehr.");
				break;

			case '0.8.3': // SQL queries for v0.8.3
				addConfigAddSql('display_home_in_index', "ENUM('Y','N') NOT NULL DEFAULT 'Y'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Es kann nun die &quot;Home&quot;-Seite in <strong>index.php</strong> angezeigt werden, anstelle der Weiterleitung.");
				break;

			case '0.8.4': // SQL queries for v0.8.4
				addCreateTableSql('history', "
`history_id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`history_subject` VARCHAR(255) NOT NULL DEFAULT 'GENERIC',
`history_userid` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`history_value` VARCHAR(255) NOT NULL DEFAULT '',
`history_added` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
`history_last_used` TIMESTAMP NULL DEFAULT NULL,
PRIMARY KEY (`history_id`),
INDEX `userid` (`history_userid`),
INDEX (`history_last_used` DESC)",
					'History of used data');

				// Register filter
				registerFilter(__FILE__, __LINE__, 'add_history_entry', 'ADD_HISTORY_ENTRY', false, true, isExtensionDryRun());

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Allgemeine Historie-Tabelle hinzugef&uuml;gt.");
				break;

			case '0.8.5': // SQL queries for v0.8.5
				// Old-lost configuration entry
				addConfigDropSql('ext_autopurge');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Uralten Konfigurationseintrag entfernt.");
				break;

			case '0.8.6': // SQL queries for v0.8.6
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_points_data` CHANGE `payment_method` `payment_method` ENUM('DIRECT','REFERRAL') NOT NULL DEFAULT 'REFERRAL'");
				addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_points_data` SET `payment_method`='REFERRAL' WHERE `payment_method` != 'DIRECT'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Referral, REFERRAL soll es &uuml;berall heissen (ist ein Typo nur mit einem R zu schreiben).");
				break;

			case '0.8.7': // SQL queries for v0.8.7
				addConfigAddSql('admin_menu_javascript', "ENUM('Y','N') NOT NULL DEFAULT 'N'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Es kann ausgew&auml;hlt werden, ob das herk&ouml;mliche JavaScrit-lose Men&uuml; oder mit JavaScript aktiv sein soll. Das herk&ouml;mliche ist erstmal Standardeinstellung, bis das JavaScript-Men&uuml; funktioniert.");
				break;

			case '0.8.8': // SQL queries for v0.8.8
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_points_data` DROP INDEX `subject`, ADD UNIQUE `subject` (`subject`)");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Der Wert in der Spalte <strong>subject</strong> sollte nur einmal vorkommen, damit eventuell nichts mehrfach durchfl&auuml;ft.");
				break;

			case '0.8.9': // SQL queries for v0.8.9
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_points_data` ADD `account_provider` ENUM('EXTENSION', 'CUSTOM') NOT NULL DEFAULT 'EXTENSION'");
				addConfigAddSql('points_remove_account', "VARCHAR(255) NOT NULL DEFAULT 'points'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("&quot;Provider&quot; hinzugef&uuml;gt, welcher nur <strong>Erweiterung</strong> oder <strong>Selbstdefiniert sein kann. Es k&ouml;nnen dann auch nur selbstdefinierte gel&ouml;scht oder editiert werden, Erweiterungen k&ouml;nnen auch nur &quot;einige&quot; Eintr&auml;ge l&ouml;schen.");
				break;

			case '0.9.0': // SQL queries for v0.9.0
				// Register filter
				registerFilter(__FILE__, __LINE__, 'init', 'GENERATE_FILE_SECRET_HASH', false, true, isExtensionDryRun());

				// Register points data
				registerExtensionPointsData('admin_add_single', 'points', 'LOCKED', 'DIRECT');
				registerExtensionPointsData('admin_add_single_ref', 'points', 'LOCKED', 'DIRECT');
				registerExtensionPointsData('admin_add_all', 'points', 'LOCKED', 'DIRECT');
				registerExtensionPointsData('admin_add_all_ref', 'points', 'LOCKED', 'DIRECT');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Filter zum Initialisieren von ext-sql_patches registriert und Eintr&auml;ge in <strong>{?_MYSQL_PREFIX?}_points_data</strong> hinzugef&uuml;gt.");
				break;
		} // END - switch
		break;

	case 'modify': // When the extension got modified
		break;

	case 'test': // For testing purposes
		break;

	case 'init': // Do stuff when extension is initialized
		// Transfer POINTS word
		if (isExtensionInstalledAndNewer('sql_patches', '0.0.3')) {
			// Okay, recent enough, so transfer the word for POINTS
			setConfigEntry('POINTS', getPointsWord());
		} // END - if

		// Init key
		setConfigEntry('secret_key', '');

		// Is the version recent enought for secret keys?
		if (isExtensionInstalledAndNewer('sql_patches', '0.3.6')) {
			// Read key from secret file
			if ((getFileHash() == '') || (getMasterSalt() == '') || (getPassScramble() == '')) {
				// Maybe need setup of secret key!
				loadIncludeOnce('inc/gen_sql_patches.php');
			} // END - if

			// Test again
			if ((getFileHash() != '') && (getMasterSalt() != '') && (getPassScramble() != '')) {
				// File hash fas generated so we can also file the secret file... hopefully.
				$hashFile = sprintf("%s%s.%s.cache", getPath(), getCachePath(), getFileHash());

				// Is the secret key file readable?
				if (isFileReadable($hashFile)) {
					// Read file
					setConfigEntry('secret_key', readFromFile($hashFile));
				} else {
					// Remove it from database
					updateConfiguration('file_hash', '');

					// Cannot read secret file!
					reportBug(__FILE__, __LINE__, 'Cannot read secret file! Please try to reload.');
				}
			} // END - if
		} // END - if
		break;

	default: // Unknown extension mode
		logDebugMessage(__FILE__, __LINE__, sprintf("Unknown extension mode %s in extension %s detected.", getExtensionMode(), getCurrentExtensionName()));
		break;
} // END - switch

// [EOF]
?>
