<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 06/19/2004 *
 * ===================                          Last change: 07/24/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-nickname.php                                *
 * -------------------------------------------------------------------- *
 * Short description : Nickname instead of the id                       *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Nickname anstelle der id                         *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2012 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	exit();
} elseif (!isMember()) {
	redirectToIndexMemberOnlyModule();
}

// Add description as navigation point
addYouAreHereLink('member', __FILE__);

if ((!isExtensionActive('nickname')) && (!isAdmin())) {
	displayMessage('{%pipe,generateExtensionInactiveNotInstalledMessage=nickname%}');
	return;
} // END - if

$isValid = false;

if (isFormSent()) {
	// Nickname was submitted so let's check if it is not already in use
	if (isPostRequestElementSet('nickname')) {
		// Check if nickname is valid
		if (preg_match('/[' . getConfig('nickname_pattern') . ']{' . getConfig('nickname_len') . ',}/', postRequestElement('nickname'), $array)) {
			// Entered nickname is valid?
			$isValid = (($array[0] == postRequestElement('nickname')) && (isNicknameUsed(postRequestElement('nickname'))));
		} // END - if
	} // END - if
} // END - if

if ($isValid === true) {
	// Nickname already in use which is the default
	$content = '{--MEMBER_NICKNAME_ALREADY_IN_USE--}';

	// Look for nickname in database (we only need just one entry so don't worry about the "LIMIT 1" !)
	$result = SQL_QUERY_ESC("SELECT `userid` FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `nickname`='%s' AND `userid` != %s LIMIT 1",
		array(
			postRequestElement('nickname'),
			getMemberId()
		), __FILE__, __LINE__);

	// Is it not in use?
	if (SQL_HASZERONUMS($result)) {
		// Prepare array
		$filterData = array(
			'history_subject' => 'NICKNAME_CHANGED',
			'history_userid'  => getMemberId(),
			'history_value'   => postRequestElement('nickname')
		);

		// Run filter chain
		runFilterChain('add_history_entry', $filterData);

		// Nickname not in use, so set it now
		SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_user_data` SET `nickname`='%s' WHERE `userid`=%s LIMIT 1",
			array(
				postRequestElement('nickname'),
				getMemberId()
			), __FILE__, __LINE__);

		// Change message
		$content = '{--MEMBER_NICKNAME_SAVED--}';
	} // END - if

	// Free result
	SQL_FREERESULT($result);

	// Load template
	displayMessage($content);
} else {
	// Do we have already submit the form?
	if (isPostRequestElementSet('nickname')) {
		loadTemplate('admin_settings_unsaved', false, '{--MEMBER_NICKNAME_IS_INVALID--}');
	} // END - if

	// Load Template
	loadTemplate('member_nickname_form');
}

// [EOF]
?>
